package dsuyasov.recognition.files;

import dsuyasov.recognition.rulesModel.CellularAutomata;
import dsuyasov.recognition.files.LoadException;
import dsuyasov.recognition.util.MessageUtil;
import dsuyasov.recognition.util.localization.Localization;
import com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl;

import java.io.File;

/**
 * @author Dmitriy Suyasov
 */
public class CellularAutomataLoader implements Loader {

    public Object load(String fileName) {
        try {
            return new CellularAutomata(DocumentBuilderFactoryImpl.newInstance().newDocumentBuilder().parse(new File(fileName)));
        } catch (LoadException e) {
            MessageUtil.setMessage(e.getMessage());
            return null;
        } catch (Exception e) {
            MessageUtil.setMessage(Localization.get(Localization.ERROR_WHILE_RULE_LOAD_MESSAGE));
            return null;
        }

        //TODO SAVE OLD RULE
    }

    public String getTitle() {
        return "CellularAutomata Files";
    }

    public String getExtension() {
        return "rul";
    }
}
