package dsuyasov.recognition.files;

import com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl;

import java.io.File;

import dsuyasov.recognition.files.LoadException;
import dsuyasov.recognition.rulesModel.sequence.AutomataSequence;
import dsuyasov.recognition.util.MessageUtil;
import dsuyasov.recognition.util.XMLUtil;
import org.w3c.dom.Document;

/**
 * @author Dmitriy Suyasov
 */
public class CellularAutomataSequenceLoader implements Loader{
    public Object load(String fileName) {
        try {
            Document document = DocumentBuilderFactoryImpl.newInstance().newDocumentBuilder().parse(new File(fileName));
            return new AutomataSequence(XMLUtil.getSingleNode(document, RULE_SEQUENCE_ROOT_NODE));
        } catch (LoadException e) {
            MessageUtil.setMessage(e.getMessage());
            return null;
        } catch (Exception e) {
            MessageUtil.setMessage("Error while trying to load the rule sequence");
            return null;
        }
    }

    public String getTitle() {
        return "CellularAutomata Sequence Files";
    }

    public String getExtension() {
        return "rse";
    }
}
