package dsuyasov.recognition.files;

import dsuyasov.recognition.files.LoadException;
import dsuyasov.recognition.rulesModel.recognition.StudiesSet;
import dsuyasov.recognition.util.XMLUtil;
import dsuyasov.recognition.util.MessageUtil;
import org.w3c.dom.Document;
import com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl;

import java.io.File;

/**
 * @author Dmitriy Suyasov
 */
public class TemplateLoader implements Loader {

    private static final String TITLE = "TemplateLoader";

    public Object load(String fileName) {
        try {
            Document document = DocumentBuilderFactoryImpl.newInstance().newDocumentBuilder().parse(new File(fileName));
            return new StudiesSet(XMLUtil.getSingleNode(document, TEMPLATE_ROOT_NODE));
        } catch (LoadException e) {
            MessageUtil.setMessage(e.getMessage());
            return null;
        } catch (Exception e) {
            MessageUtil.setMessage("Error while trying to load the template");
            return null;
        }
    }

    public String getTitle() {
        return TITLE;
    }

    public String getExtension() {
        return "tpl";
    }
}
