package dsuyasov.recognition.rulesModel;

import java.util.Map;
import java.util.HashMap;

public class Memory {

    public static final String PICTURE = "image";
    public static final String PICTURE_FILE_NAME = "pictureFileName";
    public static final String PICTURE_HEIGHT = "pictureHeight";
    public static final String PICTURE_WIDTH = "pictureWidth";

    public static final String ROOT_PANEL = "rootPanel";
    public static final String BUTTONS_PANEL = "buttonsPanel";
    public static final String MAIN_PANEL = "mainPanel";
    public static final String DESCRIPTION_PANEL = "descriptionPanel";
    public static final String IMAGE_PANEL = "imagePanel";
    public static final String MESSAGE_LABEL = "messageLabel";
    public static final String CURRENT_PAGE = "currentPage";
    public static final String APPLET = "applet";
    public static final String CURRENT_RULE = "currentRule";
    public static final String CURRENT_SEQUENCE = "currentSequence";
    public static final String FRAME = "frame";
    public static final String RULE_SELECTION_PANEL = "ruleSelectionPanel";
    public static final String SELECTED_RULE = "selectedRule";
    public static final String RULE_NAME_LABEL = "currentRuleName";
    public static final String RULE_ITEM_PANEL = "ruleItemPanel";
    public static final String SAVING_TEMPLATES = "savingTemplates";
    public static final String TEMPLATE = "template";
    public static final String MATRIX = "matrix";
    public static final String IMAGES = "images";
    public static final String SAVED_RESULTS = "savedResults";
    public static final String LAYERS_LABELS = "layersLabels";

    public static final String PROCESSING_ELEMENTS = "processingElements";

    public static final String LOCALIZATION = "localization";

    private static Memory instance;

    public static synchronized Memory getInstance() {
        if (instance == null) {
            instance = new Memory();
        }
        return instance;
    }

    private Map<String, Object> memory;

    public Memory() {
        memory = new HashMap<String, Object>();
    }

    public void addObject(String name, Object value) {
        memory.put(name, value);
    }

    public Object getObject(String name) {
        return memory.get(name);
    }

    private void removeObject(String name) {
        memory.remove(name);
    }

    public static Object get(String name) {
        return getInstance().getObject(name);
    }

    public static void add(String name, Object obj) {
        getInstance().addObject(name, obj);
    }

    public static void remove(String name) {
        getInstance().removeObject(name);
    }

    public static void dropIncreaser() {
        add("increaser", 0);
    }

    public static void incIncreaser() {
        add("increaser", getIncreaser() + 1);
    }

    public static Integer getIncreaser() {
        Integer increaser = (Integer) get("increaser");
        if (increaser == null) {
            increaser = new Integer(0);
            add("increaser", increaser);
        }
        return increaser;
    }
}