package dsuyasov.recognition.rulesModel;

import dsuyasov.recognition.util.localization.Localization;

/**
 * @author Dmitriy Suyasov
*/
public enum RuleStrategy {
    DO_NOT_CHANGE(Localization.STRATEGY_DO_NOT_CHANGE_TITLE),
    ALL_TO_COLOR(Localization.STRATEGY_ALL_TO_COLOR_TITLE),
    NONE(Localization.STRATEGY_NONE_TITLE);

    public static final String STRATEGY_DO_NOT_CHANGE = Localization.get(Localization.STRATEGY_DO_NOT_CHANGE_TITLE);
    public static final String STRATEGY_ALL_TO_COLOR = Localization.get(Localization.STRATEGY_ALL_TO_COLOR_TITLE);
    public static final String STRATEGY_NONE = Localization.get(Localization.STRATEGY_NONE_TITLE);
    private String title;

    RuleStrategy(String title) {
        this.title = Localization.get(title);
    }

    public String getTitle() {
        return title;
    }

    public static RuleStrategy getRuleStrategy(String title) {
        if (title.equals(STRATEGY_DO_NOT_CHANGE)) {
            return RuleStrategy.DO_NOT_CHANGE;
        } else if (title.equals(STRATEGY_ALL_TO_COLOR)) {
            return RuleStrategy.ALL_TO_COLOR;
        } else if (title.equals(STRATEGY_NONE)) {
            return RuleStrategy.NONE;
        } else {
            return null;
        }
    }
}
