package dsuyasov.recognition.rulesModel.checkers;

import dsuyasov.recognition.rulesModel.MatrixElement;
import dsuyasov.recognition.ui.helper.panels.cellSettingsPanel.Selecter;
import dsuyasov.recognition.util.localization.Localization;

import javax.swing.*;
import java.awt.*;

import org.w3c.dom.Node;

/**
 * Developed by Suyasov Dmitriy
 */
public class AnyColorChecker extends ColorChecker {

    public static final String TITLE = "Any Color";
    public static final String LOCALIZATION_TITLE = Localization.get(Localization.ANY_COLOR_TITLE);

    public AnyColorChecker() {}

    public AnyColorChecker(Node node) {}

    public String getTitle() {
        return TITLE;
    }

    public String getLocalizationTitle() {
        return LOCALIZATION_TITLE;
    }

    public JPanel drawElement(Selecter parent, JComponent radio) {
        JPanel mainPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 5));
        parent.getParentPanel().add(mainPanel);
        mainPanel.add(radio);
        return mainPanel;
    }

    public boolean outOfBoundsChecker() {
        return true;
    }

    public boolean internalcheck(MatrixElement[][] matrix, int x, int y) {
        return true;
    }

    public void drawCell(Graphics g, Rectangle rect) {
        g.setColor(Color.WHITE);
        g.fillRect(rect.x, rect.y, rect.width, rect.height);
        g.setColor(Color.BLACK);
        g.drawLine(rect.x + rect.width, rect.y, rect.x, rect.y + rect.height);
        g.drawLine(rect.x + rect.width / 2, rect.y, rect.x, rect.y + rect.height / 2);
        g.drawLine(rect.x + rect.width, rect.y + rect.height / 2, rect.x + rect.width / 2, rect.y + rect.height);
        g.drawRect(rect.x, rect.y, rect.width, rect.height);
    }
}
