package dsuyasov.recognition.rulesModel.generators;

import dsuyasov.recognition.ui.helper.panels.cellSettingsPanel.Selecter;
import dsuyasov.recognition.util.localization.Localization;

import javax.swing.*;
import java.awt.*;

import org.w3c.dom.Node;

/**
 * @author Dmitriy Suyasov
 *         Date 15.05.2007
 */
public class DoNothingGenerator extends LabelGenerator {

    public static final String TITLE = "Dont change symbols";
    public static final String LOCALIZATION_TITLE = Localization.get(Localization.DONT_CHANGE_SYMBOLS_TITLE);


    public DoNothingGenerator() {}

    public DoNothingGenerator(Node node) {}

    public String getTitle() {
        return TITLE;
    }

    public String getLocalizationTitle() {
        return LOCALIZATION_TITLE;
    }

    protected void generateNewLabels(int x, int y) {
        setChange(false);
    }

    public JPanel drawElement(Selecter selecter, JComponent radio) {
        JComponent parent = selecter.getParentPanel();
        JPanel mainPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 5));
        parent.add(mainPanel);
        mainPanel.add(radio);
        return mainPanel;
    }

    public void drawCell(Graphics g, Rectangle rect) {}

}
