package dsuyasov.recognition.rulesModel.sequence;

import dsuyasov.recognition.rulesModel.MatrixElement;

import java.awt.image.BufferedImage;
import java.awt.*;

/**
 * @author Dmitriy Suyasov
 */
public class PictureToMatrixElementsSpecialElement {

    public static MatrixElement[][] convert(BufferedImage image) {
        MatrixElement[][] result = new MatrixElement[image.getWidth()][image.getHeight()];
        for (int x = 0; x < image.getWidth(); x++) {
            for (int y = 0; y < image.getHeight(); y++) {
                Color color = getColor(image, x, y);
                if (!color.equals(Color.WHITE)) {
                    int t = 1;
                }
                result[x][y] = new MatrixElement(color);
            }
        }
        return result;
    }

    private static Color getColor(BufferedImage _bufferImage, int x, int y) throws IllegalArgumentException
      {
        if ( x < 0 || x > _bufferImage.getWidth() || y < 0 || y > _bufferImage.getHeight() )
          throw new IllegalArgumentException("Picture.getColor x:y illegal: "+x+":"+y+"("+
                                             _bufferImage.getWidth()+":"+_bufferImage.getHeight()+")");
        int rgb   = _bufferImage.getRGB(x,y);
        int red   = (rgb & (255<<16)) >> 16;
        int green = (rgb & (255<< 8)) >>  8;
        int blue  = (rgb &  255);
        return new Color(red,green,blue);
      }
}
