package dsuyasov.recognition.ui.helper.dialogs;

import dsuyasov.recognition.rulesModel.Memory;
import dsuyasov.recognition.util.localization.Localization;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * @author Dmitriy Suyasov
 */
public abstract class AbstractDialog extends JDialog {

    protected AbstractDialog() throws HeadlessException {
        super((JFrame) Memory.get(Memory.FRAME), true);
        setTitle(getDialogTitle());
    }

    protected void drawOkCancelButtons(JPanel mainPanel) {
        drawOkCancelButtons(mainPanel, Localization.get(Localization.ADD_DIALOG_BUTTON_NAME), Localization.get(Localization.CANCEL_DIALOG_BUTTON_NAME));
    }

    protected void drawUpdateCancelButtons(JPanel mainPanel) {
        drawOkCancelButtons(mainPanel, Localization.get(Localization.UPDATE_DIALOG_BUTTON_NAME), Localization.get(Localization.CANCEL_DIALOG_BUTTON_NAME));
    }

    protected void drawOkCancelButtons(JPanel mainPanel, String addButtonName, String cancelButtonName) {
        // Add add/cancel buttons
        JPanel buttonsPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT, 5, 5));
        mainPanel.add(buttonsPanel);
        JButton addButton = new JButton(addButtonName);
        addButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                updateAndClose();
            }
        });
        buttonsPanel.add(addButton);
        JButton cancelButton = new JButton(cancelButtonName);
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                close();
            }
        });
        buttonsPanel.add(cancelButton);

        Rectangle appletRect = ((JApplet) Memory.get(Memory.APPLET)).getBounds();
        int dialogX = appletRect.getLocation().x + (appletRect.width - ChooseSpecialRuleDialog.DIALOG_WIDTH) / 2;
        int dialogY = appletRect.getLocation().y + (appletRect.height - ChooseSpecialRuleDialog.DIALOG_HEIGHT) / 2;
        setBounds(new Rectangle(dialogX, dialogY, ChooseSpecialRuleDialog.DIALOG_WIDTH,
                ChooseSpecialRuleDialog.DIALOG_HEIGHT));
    }

    public abstract String getDialogTitle();

    protected abstract void updateAndClose();

    protected void close() {
        setVisible(false);
    }
}
