package dsuyasov.recognition.ui.helper.dialogs;

import dsuyasov.recognition.util.localization.Localization;
import dsuyasov.recognition.rulesModel.sequence.AutomataSequence;

import javax.swing.*;
import java.awt.*;

/**
 * @author Dmitriy Suyasov
 *         Date 28.05.2007
 */
public class AutomataSequenceDescriptionDialog extends AbstractDialog {

    public static final String TITLE = Localization.get(Localization.CELLULAR_AUTOMATA_SEQUENCE_DESCRIPTION_DIALOG_TITLE);

    private JTextArea descriptionArea;

    public AutomataSequenceDescriptionDialog() throws HeadlessException {
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));

        JPanel descriptionPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 10));
        mainPanel.add(descriptionPanel);
        descriptionArea = new JTextArea(AutomataSequence.getRulesSequence().getDescription(), 6, 40);
        descriptionArea.setLineWrap(true);
        JScrollPane descScroll = new JScrollPane(descriptionArea);
        descriptionPanel.add(descScroll);

        drawOkCancelButtons(mainPanel, Localization.get(Localization.UPDATE_DIALOG_BUTTON_NAME), Localization.get(Localization.CANCEL_DIALOG_BUTTON_NAME));

        setContentPane(mainPanel);
        pack();
        setVisible(true);
    }

    public String getDialogTitle() {
        return TITLE;
    }

    public void updateAndClose() {
        AutomataSequence.getRulesSequence().setDescription(descriptionArea.getText());
        close();
    }
}
