package dsuyasov.recognition.ui.page;

import dsuyasov.recognition.util.localization.Localization;
import dsuyasov.recognition.rulesModel.Memory;
import dsuyasov.recognition.ui.helper.dialogs.LearnDialog;
import dsuyasov.recognition.ui.helper.dialogs.ResolveDialog;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Dmitriy Suyasov
 *         Date 30.05.2007
 */
public class ResolvingPage extends Page {

    public static final String RESOLVING_PAGE_NAME = "resolvingPage";

    public String getUniqueKey() {
        return RESOLVING_PAGE_NAME;
    }

    public void draw() {
        JPanel root = (JPanel) Memory.get(Memory.MAIN_PANEL);
        root.removeAll();
        root.setLayout(new BoxLayout(root, BoxLayout.Y_AXIS));

        JPanel learningPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 10));
        root.add(learningPanel);
        learningPanel.add(new JLabel(Localization.get(Localization.LEARNING_DIALOG_TITLE + ": ")));

        JButton learnButton = new JButton(Localization.get(Localization.LEARN_DIALOG_BUTTON_NAME));
        learnButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                new LearnDialog();
            }
        });
        learningPanel.add(learnButton);

        JPanel resolvingPanel = new JPanel(new FlowLayout(FlowLayout.LEFT, 10, 10));
        root.add(resolvingPanel);
        resolvingPanel.add(new JLabel(Localization.get(Localization.RESOLVING_DIALOG_TITLE + ": ")));

        JButton resolveButton = new JButton(Localization.get(Localization.RESOLVE_DIALOG_BUTTON_NAME));
        resolveButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                new ResolveDialog();
            }
        });
        resolvingPanel.add(resolveButton);
    }

    public String getDescription() {
        return Localization.get(Localization.RESOLVING_PAGE);
    }
}
