package dsuyasov.recognition.ui.page;

import dsuyasov.recognition.rulesModel.Memory;
import dsuyasov.recognition.ui.helper.panels.ImagePanel;
import dsuyasov.recognition.files.PictureLoader;
import dsuyasov.recognition.util.localization.Localization;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.Hashtable;

public class ShowPicturePage extends Page {

    public static final String SHOW_PICTURE_HELPER_NAME = "showPictureHelperName";

    public void draw() {
        BufferedImage image = (BufferedImage) Memory.get(Memory.PICTURE);

        JPanel root = (JPanel) Memory.get(Memory.MAIN_PANEL);
        root.removeAll();
        root.setLayout(new BorderLayout(2,2));

        if (image != null) {
            int height = image.getHeight();
            Memory.add(Memory.PICTURE_HEIGHT, height);
            int width = image.getWidth();
            Memory.add(Memory.PICTURE_WIDTH, width);
    
            JScrollPane scrollpanel = new JScrollPane();
            ImagePanel panel = new ImagePanel(new BorderLayout());
            Rectangle rect = new Rectangle(image.getWidth(), image.getHeight());
            panel.scrollRectToVisible(rect);
            Dimension dim = new Dimension(image.getWidth(), image.getHeight());
            panel.setPreferredSize(dim);
            scrollpanel.setViewportView(panel);

            Memory.add(Memory.IMAGE_PANEL, panel);

            JPanel pictureWithControlPanel = new JPanel(new BorderLayout(2,2));

            JSlider scaleSlider = new JSlider(JSlider.VERTICAL, -1000, 1000, 1);
            scaleSlider.addChangeListener(panel.getListener());
            scaleSlider.setMajorTickSpacing(100);
            scaleSlider.setPaintTicks(true);

            //Create the label table
            Hashtable<Integer, JLabel> labelTable = new Hashtable<Integer, JLabel>();
            labelTable.put( -1000, new JLabel("10%") );
            labelTable.put( 0, new JLabel("100%") );
            labelTable.put( 1000, new JLabel("1000%") );
            scaleSlider.setLabelTable( labelTable );

            scaleSlider.setPaintLabels(true);

            pictureWithControlPanel.add(scrollpanel, BorderLayout.CENTER);
            pictureWithControlPanel.add(scaleSlider, BorderLayout.EAST);
            root.add(pictureWithControlPanel, BorderLayout.CENTER);
            panel.revalidate();
            panel.repaint();
        } else {
            JLabel label = new JLabel(Localization.get(Localization.PLEASE_LOAD_PICTURE_MESSAGE));
            root.add(label, BorderLayout.CENTER);
        }

        JPanel pictureButtonsPanel = new JPanel(new BorderLayout(2,2));
        pictureButtonsPanel.setMinimumSize(new Dimension(200, 20));
        root.add(pictureButtonsPanel, BorderLayout.SOUTH);

        JButton loadPictureButton = new JButton(Localization.get(Localization.LOAD_PICTURE_BUTTON_NAME));
        loadPictureButton.setSize(200, 20);
        loadPictureButton.addActionListener(new PictureLoader());
        pictureButtonsPanel.add(loadPictureButton, BorderLayout.EAST);
    }

    public String getDescription() {
        return Localization.get(Localization.SHOW_PICTURE_PAGE);
    }

    public String getUniqueKey() {
        return SHOW_PICTURE_HELPER_NAME;
    }

    public static String getName() {
        return "";
    }

    public static void setAsCurrent() {
        ShowPicturePage.setAsCurrent(SHOW_PICTURE_HELPER_NAME);
    }

}
