package dsuyasov.recognition.util.localization;

import dsuyasov.recognition.rulesModel.Memory;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;

/**
 * @author Dmitriy Suyasov
 */
public abstract class Localization {

    public static final String DEFAULT = RussianLocalization.LABEL;

    private static Map<String, Localization> localizations;
    public static final String SHOW_PICTURE_PAGE = "showPicturePage";
    public static final String SHOW_RULES_PAGE = "showRulesPage";
    public static final String COMBINE_RULES_PAGE = "combineRulePage";
    public static final String START_RULE_SEQUENCES_PAGE = "startRuleSequencesPage";
    public static final String CELLULAR_AUTOMATA_SEQUENCE_DESCRIPTION_DIALOG_TITLE = "ruleSequenceDescriptionDialogTitle";
    public static final String ADD_DIALOG_BUTTON_NAME = "AddDialogButtonName";
    public static final String CANCEL_DIALOG_BUTTON_NAME = "CancelDialogButtonName";
    public static final String UPDATE_DIALOG_BUTTON_NAME = "updateDialogButtonName";

    public static final String CELL_OPTION_DIALOG_TITLE = "CellOptionDialogTitle";
    public static final String QUESTION_DIALOG_TITLE = "questionDialogTitle";
    public static final String SPECIAL_ELEMENT_CHOOSER_DIALOG_TITLE = "specialElementChooserDialogTitle";

    public static final String SELECT_CHECKER_FIELD_TITLE = "selectCheckerFieldTitle";
    public static final String SPECIAL_RULE_FIELD_TITLE = "specialRuleFieldTitle";

    public static final String ADD_CHECKER_BUTTON_NAME = "addCheckerButtonName";

    public static final String REMOVE_BUTTON_NAME = "removeButtonName";
    public static final String CANNOT_DELETE_SYMBOL_CHECKER_ALERT = "canotDeleteSymbolCheckerAlert";
    public static final String ACCEPT_CHANGES_QUESTION = "acceptChangesQuestion";
    public static final String LEARNING_DIALOG_TITLE = "learningDialogTitle";
    public static final String LOAD_TEMPLATE_TO_MERGE_BUTTON_NAME = "loadTemplateToMergeButtonName";
    public static final String LOAD_TEMPLATE_BUTTON_NAME = "loadTemplateButtonName";
    public static final String MAKE_NEW_TEMPLATE_BUTTON_NAME = "makeNewTemplateButtonName";
    public static final String SYMBOLS_TO_ACCEPT_FOR_LAYERS_FIELD_TITLE = "symbolsToAcceptForLayersFieldTitle";
    public static final String START_DIALOG_BUTTON_NAME = "startButtonName";
    public static final String SELECT_SYMBOLS_ALERT = "selectSymbolsAlert";
    public static final String X_Y_SHOULD_BE_AN_INTEGER_ALERT = "xYShouldBeAnIntegerAlert";
    public static final String NEXT_DIALOG_BUTTON_NAME = "nextDialogButtonName";
    public static final String SKIP_DIALOG_BUTTON_NAME = "skipDialogButtonName";
    public static final String SAVE_RESULTS_DIALOG_BUTTON_NAME = "saveResultsDialogButtonName";
    public static final String SET_ELEMENT_FIRST_ALERT = "setElementFirstAlert";
    public static final String ERROR_WHILE_SAVING_MESSAGE = "errorWhileSavingMessage";
    public static final String NEW_RULE_SETTINGS_DIALOG_TITLE = "newRuleSettingsDialogTitle";
    public static final String COMMON_SETTINGS_TITLE = "commonSettingsTitle";
    public static final String RULE_DIMENTION_FIELD_TITLE = "ruleDimentionFieldName";
    public static final String COLORS_FIELD_TITLE = "colorsFieldTitle";
    public static final String RESULT_COLORS_FIELD_TITLE = "resultColorsFieldTitle";
    public static final String INITIAL_SETTINGS_TITLE = "initialSettingsTitle";
    public static final String STRATEGY_FIELD_TITLE = "strategyFieldTitle";
    public static final String CONTINUE_CONDITION_TITLE = "continueConditionTitle";
    public static final String CONDITION_FIELD_TITLE = "conditionFieldTitle";
    public static final String CREATE_DIALOG_BUTTON_NAME = "createDialogButtonName";
    public static final String RULE_CREATED_MESSAGE = "ruleCreatedMessage";
    public static final String WARNING_DIALOG_TITLE = "warningDialogTitle";
    public static final String SAVE_BEFORE_CREATING_QUESTION = "saveBeforeCreatingQuestion";
    public static final String RESOLVING_DIALOG_TITLE = "resolvingDialogTitle";
    public static final String USE_SAVED_TEMPLATE_BUTTON_NAME = "useSavedTemplateButtonName";
    public static final String USE_LOADED_TEMPLATE_BUTTON_NAME = "useLoadedTemplateButtonName";
    public static final String START_RECOGNIZING_BUTTON_NAME = "startRecognizingButtonName";
    public static final String RESULT_CELL_OPTIONS_DIALOG_TITLE = "resultCellOptionsDialogTitle";
    public static final String RULE_SETTINGS_DIALOG_TITLE = "ruleSettingsDialogTitle";
    public static final String RULE_NAME_FIELD_TITLE = "ruleNameFieldTitle";
    public static final String DESCRIPTION_FIELD_TITLE = "descriptionFieldTitle";
    public static final String CHOOSE_SYMBOLS_DIALOG_TITLE = "chooseSymbolsDialogTitle";
    public static final String REMOVE_SYMBOL_BUTTON_NAME = "removeSymbolButtonName";
    public static final String COLOR_CHECKER_TITLE = "colorCheckerTitle";
    public static final String COLOR_GENERATOR_TITLE = "colorGeneratorTitle";
    public static final String SYMBOL_GENERATOR_TITLE = "symbolGeneratorTitle";
    public static final String CHOOSE_COLOR_DIALOG_TITLE = "chooseColorDialogTitle";
    public static final String SELECT_RULE_ITEM_TO_SEE_DESCRIPTION = "selectRuleItemToSeeDescription";
    public static final String RULE_ITEM_TITLE = "ruleItemTitle";
    public static final String DEFAULT_NAME = "defaultName";
    public static final String DEFAULT_TITLE = "defaultTitle";
    public static final String RULES_TITLE = "rulesTitle";
    public static final String DEFAULT_RULE_SELECTED_MESSAGE = "defaultRuleSelectedMessage";
    public static final String RULE_TITLE = "ruleTitle";
    public static final String SELECTED_TITLE = "selectedTitle";
    public static final String ADD_AS_CURRENT_RULE_MENU_ITEM_NAME = "addAsCurrentRuleMenuItemName";
    public static final String SPECIAL_SYMBOL_SETTINGS_MENU_ITEM_NAME = "specialSymbolSettingsMenuItemName";
    public static final String CHANGE_BUTTON_NAME = "changeButtonName";
    public static final String PROBLEM_WHILE_INIT_DRAWER_EXCEPTION = "problemWhileInitDrawerException";
    public static final String DRAWER_TYPE_IS_UNKNOWN_EXCEPTION = "drawerTypeIsUnknown";
    public static final String NEXT_PAGE_BUTTON_NAME = "nextPageButtonName";
    public static final String PREVIOUS_PAGE_BUTTON_NAME = "previousPageButtonName";
    public static final String PLEASE_LOAD_THE_RULE_MESSAGE = "pleaseLoadTheRuleMessage";
    public static final String ADD_RULE_BUTTON_NAME = "addRuleButtonName";
    public static final String REMOVE_RULE_BUTTON_NAME = "removeRuleButtonName";
    public static final String MOVEUP_RULE_BUTTON_NAME = "moveUpRuleButtonName";
    public static final String MOVEDOWN_RULE_BUTTON_NAME = "moveDownRuleButtonName";
    public static final String RULE_SETTINGS_BUTTON_NAME = "ruleSettingsButtonName";
    public static final String LOAD_RULE_BUTTON_NAME = "loadRuleButtonName";
    public static final String SAVE_RULE_BUTTON_NAME = "saveRuleButtonName";
    public static final String SOMETHING_WRONG_WHILE_SAVING_MESSAGE = "somethingWrongWhileSavingMessage";
    public static final String NEW_RULE_BUTTON_NAME = "newRuleButtonName";
    public static final String CREATED_TITLE = "createdTitle";
    public static final String CANNOT_REMOVE_ROOT_RULE_MESSAGE = "cannotRemoveRootRuleMessage";
    public static final String SELECT_RULE_BEFORE_REMOVING_MESSAGE = "selectRuleBeforeRemovingMessage";
    public static final String REMOVED_TITLE = "removeTitle";
    public static final String SELECT_RULE_BEFORE_MOVING_MESSAGE = "selectRuleBeforeMovingMessage";
    public static final String CANNOT_MOVE_DEFAULT_RULE_MESSAGE = "cannotMoveDefaultRuleMessage";
    public static final String DOWN_TITLE = "downTitle";
    public static final String UP_TITLE = "upTitle";
    public static final String MOVED_TITLE = "movedTitle";
    public static final String ADD_RULES_TO_LIST_BUTTON_NAME = "addRulesToListButtonName";
    public static final String CLEAR_RULES_LIST_BUTTON_NAME = "clearRulesListButtonName";
    public static final String ADD_SPECIAL_SYMBOL_BUTTON_NAME = "addSpecialSymbolButtonName";
    public static final String CELLULAR_AUTOMATA_SEQUENCE_DESCRIPTION_MESSAGE = "cellularAutomataSequenceDescriptionMessage";
    public static final String CELLULAR_AUTOMATA_DESCRIPTION_MESSAGE = "cellularAutomataDescriptionMessage";
    public static final String DESCRIPTION_BUTTON_NAME = "descriptionButtonName";
    public static final String MOVEDOWN_AUTOMATA_BUTTON_NAME = "moveDownAutomataButtonName";
    public static final String MOVEUP_AUTOMATA_BUTTON_NAME = "moveUpAutomataButtonName";
    public static final String REMOVE_ELEMENT_BUTTON_NAME = "removeElementButtonName";
    public static final String CLEAR_SEQUENCE_BUTTON_NAME = "clearSequenceButtonName";
    public static final String SAVE_SEQUENCE_BUTTON_NAME = "saveSequenceButtonName";
    public static final String LOAD_SEQUENCE_BUTTON_NAME = "loadSequenceButtonName";
    public static final String REMOVE_RULE_FROM_LIST_MENU_ITEM_NAME = "removeRuleFromListMenuItemName";
    public static final String RULE_FILES_AND_DIRECTORIES_MESSAGE = "ruleFilesAndDirectoriesMessage";
    public static final String ERROR_WHILE_RULE_LOAD_MESSAGE = "errorWhileRuleLoadMessage";
    public static final String ELEMENT_CANNOT_BE_REMOVED_ALERT = "elementCannotBeRemovedAlert";
    public static final String PLEASE_LOAD_PICTURE_MESSAGE = "pleaseLoadPictureMessage";
    public static final String LOAD_PICTURE_BUTTON_NAME = "loadPictureButtonName";
    public static final String RULE_SEQUENCE_LOADING_TITLE = "ruleSequenceLoadingTitle";
    public static final String LOAD_CURRENT_RULE_SEQUENCE_BUTTON_NAME = "loadCurrentRuleSequenceButtonName";
    public static final String LEARN_DIALOG_BUTTON_NAME = "learnDialogButtonName";
    public static final String RESOLVE_DIALOG_BUTTON_NAME = "resolveDialogButtonName";
    public static final String PLEASE_LOAD_PICTURE_BEFORE_PROCESSING_MESSAGE = "pleaseLoadPictureBeforeProcessingMessage";
    public static final String ALL_SYMBOLS_TITLE = "allSymbolsTitle";
    public static final String ONE_OF_THE_SYMBOLS_TITLE = "oneOfTheSymbolsTitle";
    public static final String NO_SYMBOLS_TITLE = "noSymbolsTitle";
    public static final String NO_OF_SYMBOLS_TITLE = "noOfSymbolsTitle";
    public static final String LIGHTER_THEN_TITLE = "lighterThenTitle";
    public static final String GENERATED_SYMBOLS_TITLE = "generatedSymbolsTitle";
    public static final String FIXED_COLOR_TITLE = "fixedColorTitle";
    public static final String DARKER_THEN_TITLE = "darkerThenTitle";
    public static final String BETWEEN_COLORS_TITLE = "betweenColorsTitle";
    public static final String ANY_COLOR_TITLE = "anyColorTitle";
    public static final String ADD_SYMBOL_TITLE = "addSymbolTitle";
    public static final String DONT_CHANGE_SYMBOLS_TITLE = "dontChangeSymbolsTitle";
    public static final String INCREECE_GENERATOR_TITLE = "increeceGeneratorTitle";
    public static final String MIDDLE_GREY_TITLE = "middleGreyTitle";
    public static final String MINIMUM_OF_GENERATED_TITLE = "minimumOfGeneratedTitle";
    public static final String NOT_CHANGE_COLOR_TITLE = "notChangeColorTitle";
    public static final String REMOVE_SYMBOL_TITLE = "removeSymbolTitle";
    public static final String REPLACE_SYMBOL_TITLE = "replaceSymbolTitle";
    public static final String CHOOSE_CHECKER_FIELD_TITLE = "chooseCheckerFieldTitle";
    public static final String CHECKER_TITLE = "checkerTitle";
    public static final String SYMBOLS_FOR_REMOVING_FIELD_TITLE = "symbolsForRemovingFieldTitle";
    public static final String ADD_CHECKER_FOR_USAGE_BUTTON_NAME = "addCheckerForUsageButtonName";
    public static final String CLEAR_CHECKERS_BUTTON_NAME = "clearCheckersButtonName";
    public static final String UNIT_CELLS_TITLE = "unitCellsTitle";
    public static final String SPLIT_INTO_SYMBOLS_TITLE = "splitIntoSymbolsTitle";
    public static final String OUTPUTTER_TITLE = "outputterTitle";
    public static final String MARK_TOP_LEFT_ELEMENT_TITLE = "markTopLeftElementTitle";
    public static final String LABEL_TITLE = "labelTitle";
    public static final String GET_METRIC_TITLE = "getMetricTitle";
    public static final String ANY_CHANGE_CONDITION_TITLE = "anyChangeConditionTitle";
    public static final String ONCE_CONTINUE_CONDITION_TITLE = "onceContinueConditionTitle";
    public static final String WHILE_MAKE_SENCE_CONTINUE_CONDITION_TITLE = "whileMakeSenceContinueConditionTitle";
    public static final String WHILE_FIRST_OCCURED_CONTINUE_CONDITION_TITLE = "whileFirstOccuredContinueConditionTitle";
    public static final String DIMENTION_1_CELL_TITLE = "dimention1CellTitle";
    public static final String DIMENTION_9_CELLS_TITLE = "dimention9CellsTitle";
    public static final String DIMENTION_25_CELLS_TITLE = "dimention25CellsTitle";
    public static final String STRATEGY_DO_NOT_CHANGE_TITLE = "strategyDoNotChangeTitle";
    public static final String STRATEGY_ALL_TO_COLOR_TITLE = "strategyAllToColorTitle";
    public static final String STRATEGY_NONE_TITLE = "strategyNoneTitle";
    public static final String COLORS_BLACK_AND_WHITE_COLORS_TITLE = "colorsBlandWhiteColorsTitle";
    public static final String COLORS_RGB_COLORS = "colorsRGBColors";
    public static final String PROGRAM_TITLE = "programTitle";
    public static final String LOAD_TEMPLATE_ALERT = "loadTemplateAlert";
    public static final String BACK_TO_BEGIN_DIALOG_BUTTON_NAME = "backToBeginDialogButtonName";
    public static final String RUN_DIALOG_BUTTON_NAME = "runDialogButtonName";
    public static final String RUN_AUTOMAT_DIALOG_BUTTON_NAME = "runAutomatDialogButtonName";
    public static final String RUN_STEP_DIALOG_BUTTON_NAME = "runStepDialogButtonName";
    public static final String RESOLVING_PAGE = "resolvingPage";
    public static final String RULE_IN_THE_LOOP_MESSAGE = "ruleInTheLoopMessage";
    public static final String CROSS_BUTTON_NAME = "crossButtonName";
    public static final String CUSTOM_SYMBOL_TITLE = "customSymbolTitle";
    public static final String PREDEFINE_SYMBOL_TITLE = "predefineSymbolTitle";
    public static final String LABEL_NAME_TITLE = "labelNameTitle";
    public static final String LABEL_DESCRIPTION = "labelDescription";
    public static final String ANY_CHANGE_CONDITION_DESCRIPTION = "anyChangeConditionDescription";
    public static final String SPLITTING_DESCRIPTION = "splittingDescription"; // TODO
    public static final String MARKING_DESCRIPTION = "markingDescription";
    public static final String DISPLAYING_DESCRIPTION = "displayingDescription";
    public static final String RESULTS_LIST_TITLE = "resultsListTitle";
    public static final String ELEMENT_TITLE = "elementTitle";
    public static final String LABEL_OF_TRANSITION_TITLE = "labelOfTransitionTitle";
    public static final String SELECT_LABEL_FIRST_MESSAGE = "selectLabelFirstMessage";
    public static final String LABELS_FOR_MARKING_TITLE = "labelsForMarkingTitle";
    public static final String ONE_SYMBOL_SHOULD_BE_SPECIFIED_MESSAGE = "oneSymbolShouldBeSpecifiedMessage";
    public static final String CELL_AUTOMAT_PROCESSED_TITLE = "cellAutomatProcessedTimesTitle";
    public static final String LABELS_TO_DISPLAY_TITLE = "labelsToDisplayTitle";
    public static final String LABELS_TO_USE_TITLE = "labelsToUseTitle";
    public static final String USE_GENERATED_LABELS_TITLE = "useGeneratedLabelsTitle";
    public static final String CHECK_SELECTED_LABELS_MESSAGE = "checkSelectedLabelsMessage";

    static {
        localizations = new HashMap<String, Localization>();
        Localization loc = new EnglishLocalization();
        localizations.put(loc.getLabel(), loc);
        loc = new RussianLocalization();
        localizations.put(loc.getLabel(), loc);
    }

    public static String get(String name, String... args) {
        String value = getInstance().getValue(name);
        for (int iLoop = 0; iLoop < args.length; iLoop++) {
            String arg = args[iLoop];
            String label = "{" + iLoop + "}";
            while (value.indexOf(label) > 0) {
                value = value.substring(0, value.indexOf(label)) + arg +
                        value.substring(value.indexOf(label) + label.length());
            }
        }
        return value;
    }

    public static Set<String> getLocalizationLabels() {
        return localizations.keySet();
    }

    private static Localization localization;

    public static Localization getInstance() {
        if (localization == null) {

            // Get Localization Labels
            String locStr = (String) Memory.get(Memory.LOCALIZATION);
            if (locStr == null || locStr.length() == 0)
                locStr = DEFAULT;

            localization = localizations.get(locStr);
        }
        return localization;
    }

    public abstract String getValue(String name);
    public abstract String getLabel();

}